<?php

    namespace thebuggenie\modules\oauth2_google;

    use League\OAuth2\Client\Provider\GoogleUser;
    use thebuggenie\core\entities\Module;
    use thebuggenie\core\entities\tables\Users;
    use thebuggenie\core\entities\User;
    use thebuggenie\core\framework;

    /**
     * Autogenerated module Oauth2-google
     *
     * @author
     * @version 0.1
     * @license http://opensource.org/licenses/MPL-2.0 Mozilla Public License 2.0 (MPL 2.0)
     * @package oauth2-google
     * @subpackage core
     */

    /**
     * Autogenerated module Oauth2-google
     *
     * @package oauth2-google
     * @subpackage core
     *
     * @Table(name="\thebuggenie\core\entities\tables\Modules")
     */
    class Oauth2_google extends Module
    {

        const VERSION = '1.1';

        protected $_has_config_settings = true;
        protected $_name = 'oauth2_google';
        protected $_longname = 'Google OAuth2 support';
        protected $_description = 'Adds Google as an OAuth2-provider for user authentication and registration.';
        protected $_module_config_title = 'Google OAuth2 settings';
        protected $_module_config_description = 'Set up the Oauth2-google module from this section';

        /**
         * Return an instance of this module
         *
         * @return Oauth2_google
         */
        public static function getModule()
        {
            return framework\Context::getModule('oauth2_google');
        }

        protected function _initialize()
        {
            require THEBUGGENIE_MODULES_PATH . 'oauth2_google' . DS . 'vendor' . DS . 'autoload.php';
        }

        protected function _addListeners()
        {
            framework\Event::listen('core', 'login_form_pane', array($this, 'listenLoginButtons'));
        }

        protected function _install($scope)
        {
        }

        protected function _loadFixtures($scope)
        {
        }

        protected function _uninstall()
        {
        }

        public function getSettings()
        {
            return [
                'client_id' => $this->getSetting('client_id'),
                'client_secret' => $this->getSetting('client_secret')
            ];
        }

        public function listenLoginButtons(framework\Event $event)
        {
            include_component('oauth2_google/loginbutton');
        }

        public function getOrCreateUserByOwnerDetails(GoogleUser $ownerDetails)
        {
            $email = $ownerDetails->getEmail();
            $user = Users::getTable()->getByEmail($email);

            if (!$user instanceof User) {
                $user = new User();
                $user->setPassword(User::createPassword());
                $user->setUsername($email);
                $user->setRealname($ownerDetails->getName());
                $user->setEmail($email);
                $user->setOpenIdLocked();
                $user->setActivated();
                $user->setEnabled();
                $user->setValidated();
                $user->save();
            }

            return $user;
        }

        public function getFontAwesomeIcon()
        {
            return 'google';
        }

        public function getFontAwesomeColor()
        {
            return '#555';
        }

    }
